function [corr_coeffs power]= autocorrcoeffs_2D(M)
    %input: Array M (1D, 2D or 3D), zero-mean
    %output: - vector corr_coeffs with correlation coefficients
    %          (along 1st, 2nd and 3rd dimension)
    %        - estimated power (variance) of M
    N = length(M(:)); %total number of samples
    shifts = [1 0];
    r = zeros(1,2); %initiating covariance vector
    for i = 1:2
        r(i) = sum(sum(M(1:end-shifts(1),1:end-shifts(2))...
        .*M(shifts(1)+1:end,shifts(2)+1:end)))/N; 
        shifts = circshift(shifts,[0 1]);
    end
    power = sum(sum(sum(M.^2)))/N;
    corr_coeffs = r/power;
end