function [a norm_power] = est_2Dpredcoeffs(f,W, debug)
      
    if(nargin < 3)
        debug = 0;
    else
        debug = 1;
    end

    %Compute autocorrelation coefficients:
    rho = autocorrcoeffs_2D(f);
    rho_h=rho(1);
    rho_v=rho(2);

    W_0 = [0 0; W];
    x_0 = W_0(:,1);
    y_0 = W_0(:,2);
    m = W(:,1);
    n = W(:,2);
    A = zeros(length(W_0),length(W)); 
    r_w = zeros(length(W_0),1);
    for i = 1:length(W_0)
        r_w(i) = rho_v^x_0(i)*rho_h^y_0(i);
        for j = 1:size(W,1)
                A(i,j) = rho_v^abs((x_0(i)-m(j)))*rho_h^abs((y_0(i)-n(j)));
        end
    end
    
    a = A(2:end,:)\r_w(2:end);
    %power = r_w(1)*a'*r_w(2:end);
    norm_power = 1-a'*r_w(2:end);

    %Scaling to sum to one:
    weight = sum(a);
    a = a/weight;
    if(debug == 1)
        disp('2D prediction parameters')
        rho
        A
        r_w
        weight
        a
        norm_power
        gain = 1/norm_power
    end
end
