function [a norm_power] = est_3Dpredcoeffs(f,W,debug)
    % W - prediction window: matrix with coordinates as row vectors
    % f -input array (3D)
    
    if(nargin < 3)
        debug = 0;
    else
        debug = 1;
    end
    %----Compute autocorrelation coefficients:----
    rho = autocorrcoeffs_3D(f);
    rho_h=rho(1);
    rho_v=rho(2);
    rho_t=rho(3);
   
    % ---- LPC analysis -----
    % Defining windows and counters
    W_0 = [0 0 0; W];
    x_0 = W_0(:,1);
    y_0 = W_0(:,2);
    n_0 = W_0(:,3);
    i = W(:,1);
    j = W(:,2);
    k = W(:,3);
    A = zeros(size(W_0,1),size(W,1)); 
    r_w = zeros(size(W_0,1),1);
    % Generating matrix A and vector r_w:
    for m = 1:size(W_0,1) % for all (x,y,n)
        r_w(m) = rho_v^x_0(m)*rho_h^y_0(m)*rho_t^n_0(m); %vil dette bli noe annet enn 1?
        for n = 1:size(W,1) % for all (i,j,k)
                A(m,n) = rho_v^abs(x_0(m)-i(n))*rho_h^abs(y_0(m)-j(n))*rho_t^abs(n_0(m)-k(n));
        end
    end
    % Solving for a and power:
    a = A(2:end,:)\r_w(2:end);
    %power = r_w(1)*a'*r_w(2:end)
    norm_power = 1-a'*r_w(2:end);
    
    %Scaling to sum to one:
    weight = sum(a);
    a = a/weight;
    
    if(debug == 1)
        disp('3D prediction parameters')
        rho
        A
        r_w
        weight
        a
        norm_power
        gain = 1/norm_power
    end
end
