function x_q = inv_deadzone_quantizer(q_level,q_param)
    %% Map quantizations level back to corresponding representation value
    % input: q_level - quantization level (integer)
    %        dz_offset - (two-sided) width of dead-zone interval
    %        range - one-sided range
    %        L - number of quantization levels
    % output: x_q - representation value
    L = q_param.L;
    range = q_param.range;
    dz_offset = q_param.dz_offset;
    
    step_size = (2*range-dz_offset)/(L-1);
    %   x_q - representation level
    q_level_unsigned = abs(q_level);
    %x_mapped = max(0,(-0.5*(dz_offset-step_size))/step_size);
    x_q_unsigned = q_level_unsigned*step_size+0.5*(dz_offset-step_size);
    x_q = sign(q_level)*x_q_unsigned;
end