function im_sinus = make_sinus_image(im_size, num_of_periods, intensity, amplitude,angle)
%making an image with sinusoidal stripes of with mean "intensity" and
%amplitude "amplitude"

im_sinus=zeros(im_size);
N = size(im_sinus,2);
M = size(im_sinus,1);
kx = cos(angle*pi/180)*num_of_periods/N;
ky = sin(angle*pi/180)*num_of_periods/N;
u = (1:N)*(2*kx*pi);
U = ones(M,1)*u;
v = (1:M)*(2*ky*pi);
V = v'*ones(1,N);

im_sinus = amplitude*sin(U+V)+intensity;
im_sinus = uint8(256*im_sinus);
end