% Make test images for DPCM (without MC)

% Many images, high res(Very slow when SR-coding):
% N = 10; %number of test images
% im_size = 256;
% number_of_periods = 11.5;
% SNR_factor = 50;
% exp_time = 1;

% Short version for efficient testing:
N = 5; %number of test images
im_size = 128;
number_of_periods = 11.5;
SNR_factor = 50;
exp_time = 1;

sine_dc = 0.6; % DC level of sine images
sine_amp = 0.05*sine_dc; % Amplitude of sine images
noise_std = sine_dc/(SNR_factor*sqrt(exp_time));
skew_factor = 20;
angle = 10;
sine_angles = angle +skew_factor*rand(1,N); % Angles around 45 degrees;
%sine_angles = 45+ zeros(1,N); %constant angle
im_mat = uint8(zeros(im_size, im_size, N));
for i = 1:N
    im_sine = make_sinus_image(im_size, number_of_periods, sine_dc, sine_amp, sine_angles(i));
    im_mat(:,:,i) = im_sine+(uint8(256*noise_std*randn(im_size)));
end

video_mat = double(im_mat);