function video = video_maker(im_in, video_param, image_param)
    size_out = video_param.size_out;
    frames = video_param.frames;
    frame_shift = video_param.frame_shift;
    exp_time = video_param.exp_time;
    SNR_factor = image_param.SNR_factor;
    intensity = image_param.intensity;

    if(SNR_factor ==0)
        noise_std = 0;
    else
        noise_std = intensity/(SNR_factor*sqrt(exp_time));
    end
    %noise_std = noise_std_normalized*sqrt(exp_time);
    res_ratio = min(size(im_in)./size_out); %The ratio between the low and high resolution, assuming a rectangular image
    video = zeros([size_out frames]); %Making a 3 dim matrix for video, last index is frame number
    for i = 1:frames
        y=0;
        x=0;
        shift_highres = frame_shift.*res_ratio;
        size_highres = size_out.*res_ratio;
        y = ((1:size_highres(1))+round(shift_highres(1)*(i-1))); %must round to make integer index. Any better solutions? Interpolation?
        x = ((1:size_highres(2))+round(shift_highres(2)*(i-1)));
        if((y(end) <= size(im_in,1)) && (x(end) <= size(im_in,2))) %cheking if the input image is large enough
            im_highres = im_in(y,x);
            im_lowres = imresize(im_highres, size_out);
        else
            i = frames+1; %(noen smartere måte å avbryte forløkke på?)
        end
        video(:,:,i) = im_lowres+(uint8(256*noise_std*randn(size_out)));
        %video(:,:,i) = im_lowres;
    end
end