function plot_stk_elev(data)

N = size(data,1);

% Remove spurious elevations caused by a bug in STK
data = stk_remove_spurious(data);

% This line eliminates all rows that are filled with just zeros. They are
% separators to separate between the passes.
data(all(ismember(data,[0 0 0 0 0 0 0]),2),:)=[];

% Takes in the date vector (first six elements) and converts it to MATLABs
% serial date format.
time_axis = datenum(data(:,1:6));

plot(time_axis,data(:,7));
datetick('x','HH:MM');

end

