function video_param = compute_and_set_video_param(satcam_param,frame_rate, frames)
image_speed = satcam_param.image_speed;
array_size = satcam_param.array_size;
reset_time = satcam_param.reset_time;
% frame_rate = satcam_param.frame_rate;
% frames = satcam_param.frames;

approx_res_ratio = 10; % Approximate ratio between the low and high resolution
%-do something with the ratio stuff?
lowres = array_size*[1 1];  % Resolution of the resulting video frames
frame_shift = (1/frame_rate)*image_speed*[0 1];
highres_shift = round(frame_shift*approx_res_ratio); % Make sure this is an integer!
res_ratio = highres_shift/frame_shift; % Computed ratio between low and high resolution
highres = round((lowres(1)*res_ratio)+[0 (highres_shift(2)*frames)]); %The resolution of the "analog" inherent image
exp_time = 1./frame_rate-reset_time;
% Defining the output struct (including the corresponding satcam_param as a nested struct):
video_param = struct('size_out',lowres,'frames',frames,'frame_rate',frame_rate,...
                'frame_shift',frame_shift, 'highres',highres,'exp_time', exp_time,...
                'satcam_param',satcam_param); 
end