function display_struct_rows_rec(struct_in)
    % Displays an 1byN array of structs as a table, with the field names in the
    % first column, and struct number in the first row.

    % Make column of row names----------
    %Initialize row names and row counter:
    names{1} =' ';
    counter = 1;
    %Pick up names from the structs recursively:
    [names counter] = struct_names_rec(struct_in,names,counter);

    %making a column with whitespaces to put inbetween the columns:
    empty_col = char(ones(length(names),1)*'  ');
    matrix_out = [];
    matrix_out = [strvcat(names) empty_col];
    
    % Fill columns with struct values-----------
    
    M = length(names); %number of rows
    N = size(struct_in,2); %number of columns
    cell_in = struct2cell(struct_in);
    for i = 1:N
        str_cell = cell(M,1);
        %Make header for column:
        str_cell{1} = num2str(i);
        counter=1;

        % Fetch struct values recursively:
        [str_cell counter] = struct_values_rec(cell_in(:,1,i),str_cell, counter);

        % Extend output matrix with one column:
        matrix_out = [matrix_out strvcat(str_cell) empty_col]; 
    end

    disp(matrix_out)
end

%               1            2            3            
% T             5792.3301    5792.3301    5730.1231    
% speed_sat_OH  7007.4351    7007.4351    7083.5088    
% image_cov     423326.2607  423326.2607  247049.1554  
% image_cov_wl  21.1663      21.1663      12.3525      
% spat_res      3307.2364    1653.6182    965.0358     
% image_speed   2.1188       4.2376       7.3402       
% height_sat    600          600          550          
% FOV           45           45           30           
% array_size    128          256          256          
% exp_time      0.03         0.03         0.03         
% frame_rate    25           25           10           
% frames        50           50           30    
% my_struct
%  |-field1
%  |-field2
%  '-field3