function [im_comb im_comb_cropped] = video_frame_comb(video, video_param, frames_to_combine)

frame_shift = video_param.frame_shift;
lowres = video_param.size_out;
%frames = video_param.frames;
frames = frames_to_combine;

total_shift = ceil(frames*frame_shift);
im_comb = zeros(lowres+total_shift); %Defining the size of the resulting combined image
im_comb(1:size(video,1),1:size(video,2))=video(:,:,1); %Placing the firs frame
for i = 2:frames
   % Zero-padding and interpolation:
   im_in = video(:,:,i); % Rename (too similar to interpolation...)
   % input grid:
   x_in = (1:lowres)+((i-1)*frame_shift(2));
   y_in = (1:lowres)+((i-1)*frame_shift(1));
   [X_in Y_in] = meshgrid(x_in,y_in);
   % interpolated grid:
   x_interp = 1:size(im_comb,2);
   y_interp = 1:size(im_comb,1);
   [X_interp Y_interp] = meshgrid(x_interp,y_interp);
   % Interpolation and zero filling:
   im_interp = interp2(X_in,Y_in,im_in,X_interp,Y_interp);
   im_interp(isnan(im_interp)) = 0;
   % Adding to the resulting image:
   im_comb = im_comb+im_interp;
end
im_comb = uint8(im_comb/frames);
im_comb_cropped = uint8(im_comb(:,total_shift(2):(end-total_shift(2)-1)));

end