function im_chirp = make_chirp_image(f_x)

if(nargin==0)
    f_x = [5 10 20 40 70 100]; %cycles per image
end
f_x
N = length(f_x);
len = 200;
im_chirp = zeros(300,N*len); %Set size and resolution of chirp image
f_x = f_x/(N*len); %cycles per pixel

intensity= 0.5;
amplitude= 0.3;

start_pos = 1;
phase = zeros(1,N);
phase(1) = 0;
for i = 1:N
    end_pos = start_pos+len-1;
    n = 0:len-1;
    sine = amplitude*sin(2*pi*f_x(i)*n+phase(i))+intensity;
    im_chirp(:,start_pos:end_pos) = ones(size(im_chirp,1),1)*sine;
    start_pos = end_pos+1;
    phase(i+1) = phase(i)+2*pi*f_x(i)*len; 
end

im_chirp = uint8(256*im_chirp);
