function im_sinus = make_sinus_image2(im_size, period, intensity, amplitude,angle)
%making an image with sinusoidal stripes of with mean "intensity" and
%amplitude "amplitude"
%period is the period of the sine in #pixels

im_sinus=zeros(im_size);
N = size(im_sinus,2);
M = size(im_sinus,1);
kx = cos(angle*pi/180)*(1/period);
ky = sin(angle*pi/180)*(1/period);
u = (1:N)*(2*kx*pi);
U = ones(M,1)*u;
v = (1:M)*(2*ky*pi);
V = v'*ones(1,N);

im_sinus = amplitude*sin(U+V)+intensity;
end