%% Simulation of motion blur
close all
clear all

%To save figures:
%saveas(gcf, '/home/marianne/Skole/NUTS/report2/matlabfigurer/name', 'fig')
%saveas(gcf, '/home/marianne/Skole/NUTS/report2/matlabfigurer/name', 'pdf')

% number_of_pixels = 512;
% intensity = 0.6;
% amplitude = 0.05*intensity;
% angle = 0;
% number_of_periods = [2 3 4 5 6 10];
% v_im = 0.02; %image velocity relative to image size!
% t_int = 1;
% blur_len = v_im*t_int; %blur length relative to image size!!!
% blur_angle = 0;
% 
% for i = 1:length(number_of_periods)
%     im_sinus = make_sinus_image(number_of_pixels, number_of_periods(i),intensity,amplitude,angle);
%     [im_blurred_mat{i} h_mb{i}] = motionblur_maker(im_sinus, blur_len*number_of_pixels, blur_angle);
%     im_blurred_stack{i} = im_blurred_mat{i}{2};
% end

%plot_im_stack(im_blurred_stack,'q')
% 
% 
%% ----Plotting of frequency response:
% v_im = 1;
% t_int = 1;
% u = linspace(0,10,1000);
% H = 1./(pi*u*v_im).*sin(pi*u*v_im*t_int);
% figure(10)
% plot(u,H)
% grid on
% xlabel('Frequency [cycles/image]')
% hold on
%% Computing zeros:
% clear all
% syms v
% syms v_im
% syms t_int
% H = 1/(pi*v*v_im)*sin(pi*v*v_im*t_int);
% %diff_H = diff(H);
% v = solve(H)


%% plotting zeros:
%v_im = 0.0185; %corresponding parameters: 550,45
v_im = 0.024; %corresponding to image coverage 300 km, V' = 7.16 (h_sat = 500)
t_int = linspace(0,5, 100);
im_cov = 300;
zerocrossings = 1./(v_im*t_int);
zero_wavelengths = im_cov./zerocrossings;
figure
plot(t_int,zero_wavelengths)
xlabel('Integration time [s]')
ylabel('Wavelength at first zero [km]')

figure
plot(t_int,zerocrossings)
xlabel('Integration time [s]')
ylabel('Wavelength at first zero [km]')
axis([0 5 0 200])


v_im = [0.0107 0.0133 0.0185 0.0287 0.0374];
%corresponding parameters: 650,60 - 550,60 - 550,45 - 550,30 - 450,30
im_cov = [648 532 382 247 193]; %corresponding image coverage
t_int = linspace(0,10, 100);
figure
colours = ['b' 'r' 'g' 'c' 'm'];
for i = 1:length(v_im)
    zerocrossings = 1./(v_im(i)*t_int);
    zero_wavelengths = im_cov(i)./zerocrossings;
    plot(t_int,zero_wavelengths,colours(i))
    hold on
end
legend('650,60','550,60', '550,45', '550,30', '450,30')
xlabel('Integration time [s]')
ylabel('Wavelength at first zero [km]')

% %Computing second derivative to find "vendepunkt":
% delta_x = u(2)-u(1);
% ddH = (H(1:end-2)-2*H(2:end-1)+H(3:end))/delta_x^2;
% plot(u(2:end-1),10*ddH)
% grid on
% 
% syms u
% H = 1/(pi*u*v_im)*sin(pi*u*v_im*t_int);
% diff_H = diff(diff(H))
% solve(diff_H)

%% Testing with chirp image:
%---parameters----
chirp_freq = [5 10 15 20 25 30];
im_chirp = make_chirp_image(chirp_freq);
t_int = [1 2 3];
v_im = 0.024; %image velocity relative to image size!
blur_len = v_im*t_int; %blur length relative to image size!!!
blur_angle = 0;
number_of_pixels = size(im_chirp,2);
% %---------------------------
% make chirp image:
[im_blurred_mat_chirp h_mb] = motionblur_maker(im_chirp, blur_len*number_of_pixels, blur_angle);
%plot chirp image:
% titles{1}=['Sine frequencies: ' mat2str(chirp_freq) ', Original image'];
% for i = 1:length(blur_len)
%     title = ['Sine frequencies: ' mat2str(chirp_freq) ', exposure time = ' num2str(t_int(i)) ];
%     titles{i+1} = title;
% end
% plot_im_stack(im_blurred_mat_chirp,'l', titles)


%% Plot blur and frequency response together
% clear title
% figure
% subplot(5,1,1)
% %freq response:
% u = linspace(1,100,1000);
% color = ['r' 'g' 'b'];
% for i = 1:length(blur_len)
%     H = 1./(pi*u*v_im).*sin(pi*u*blur_len(i));
%     plot(u,H,color(i))
%     hold on
% end
% grid on
% %title('Motion blur filter in the frequency domain')
% xlabel('Frequency [cycles/image]')
% axis([2.5 32.5 -0.7 3])
% legend( ['t_{int} =' num2str(t_int(1))],['t_{int} =' num2str(t_int(2))],['t_{int} =' num2str(t_int(3))])
% hold off
% %images:
% subplot(5,1,2)
% imshow(im_blurred_mat_chirp{1})
% title('freq: [5 10 15 20 25 30], original')
% subplot(5,1,3)
% imshow(im_blurred_mat_chirp{2})
% title('freq: [5 10 15 20 25 30], t_{int} = 1')
% subplot(5,1,4)
% imshow(im_blurred_mat_chirp{3})
% title('freq: [5 10 15 20 25 30], t_{int} = 2')
% subplot(5,1,5)
% imshow(im_blurred_mat_chirp{4})
% title('freq: [5 10 15 20 25 30], t_{int} = 3')
% 
% titles = {'(b) Original image', '(c) Exposure time 1 s', '(d) Exposure time 2 s', '(e) Exposure time 3 s'}
% plot_im_stack(im_blurred_mat_chirp,'l', titles)
% 
% 
% 
% %% --- Deblurring a single chirp image:
% blur_index = 4;
% im_blurred = im_blurred_mat_chirp{blur_index};
% h_motionblur = h_mb{blur_index};
% num_it = 15;
% h_gaussian = fspecial('gaussian', 15, 7);
% im_r_plain = deconvlucy(im_blurred,h_motionblur,num_it);
% im_edgetaper = edgetaper(im_blurred, h_gaussian);
% im_r_edgetaper = deconvlucy(im_edgetaper,h_motionblur,num_it);
% 
% % plot with frequency response:
% figure
% subplot(4,1,4)
% imshow(im_r_edgetaper)
% subplot(4,1,3)
% imshow(im_blurred)
% subplot(4,1,2)
% imshow(im_blurred_mat_chirp{1})
% subplot(4,1,1)
% u = linspace(min(chirp_freq),max(chirp_freq),1000);
% H = 1./(pi*u*v_im).*sin(pi*u*blur_len(blur_index-1));
% plot(u,H)
% grid on
% xlabel('Frequency [cycles/image]')
% axis([min(chirp_freq)-2.5 max(chirp_freq)+2.5 -0.52 1.9])

% % Deblurring several chirp images:
% titles{1}=['Sine frequencies: ' mat2str(chirp_freq) ', Original image'];
% im_r_mat_chirp{1} = im_blurred_mat_chirp{1};
% for i = 1:length(blur_len)
%     im_blurred = im_blurred_mat_chirp{i+1};
%     h_motionblur = h_mb{i+1};
%     im_r_plain = deconvlucy(im_blurred,h_motionblur,num_it);
%     im_edgetaper = edgetaper(im_blurred, h_gaussian);
%     im_r_edgetaper = deconvlucy(im_edgetaper,h_motionblur,num_it);
% 
%     im_r_mat_chirp{i+1} = im_r_edgetaper;
%     title = ['Sine frequencies: ' mat2str(chirp_freq) ', exposure time = ' num2str(t_int(i)) ];
%     titles{i+1} = title;
% end
% titles = {'(b) Original image', '(c) Exposure time 1 s', '(d) Exposure time 2 s', '(e) Exposure time 3 s'}
% plot_im_stack(im_r_mat_chirp,'l', titles)
% 

%title('recovered image')
%difference between recovered and original image:
% im_diff = im_blurred_mat_chirp{1}-im_r_edgetaper;
% figure 
% imshow(im_diff)

%% blur/deblur images:
N_px = 256;
nr_periods = 20;
intensity = 0.6;
amplitude = 0.05*intensity;
angle = 10;

im_sine = make_sinus_image(N_px, nr_periods, intensity, amplitude,angle);

t_int = 1;
v_im = 0.024; %image velocity relative to image size!
blur_len = v_im*t_int;
[im_blurred_sine h_mb] = motionblur_maker(im_sine, blur_len*N_px, blur_angle);

num_it = 15;
h_gaussian = fspecial('gaussian', 15, 7);
%im_r_plain = deconvlucy(im_blurred_sine{2},h_mb{2},num_it);
im_edgetaper = edgetaper(im_blurred_sine{2}, h_gaussian);
im_r_edgetaper = deconvlucy(im_edgetaper,h_mb{2},num_it);
% 
% clear title
% figure
% imshow(im_sine)
% title('original image')
% figure
% imshow(im_blurred_sine{2})
% title('blurred image')
% figure
% imshow(im_r_edgetaper)
% title('recovered image')

%% blur/deblur several images:
t_int = 0.5:0.1:3;
v_im = 0.024; %image velocity relative to image size!
blur_len = v_im*t_int;

[im_blurred_sine h_mb] = motionblur_maker(im_sine, blur_len*N_px, blur_angle);
im_r_mat{1} = im_blurred_sine{1};
im_r_mat_cut{1} = im_blurred_sine{1}(N_px/2-25:N_px/2+25,N_px/2-50:N_px/2+50);
im_blurred_cut{1} = im_blurred_sine{1}(N_px/2-25:N_px/2+25,N_px/2-50:N_px/2+50);
%im_diff_mat{i+1} = im_r_mat_cut{1}-im_r_mat_cut{1};

for i = 1:length(blur_len)
    im_blurred = im_blurred_sine{i+1};
    im_blurred_cut{i+1} = im_blurred_sine{i+1}(N_px/2-25:N_px/2+25,N_px/2-50:N_px/2+50);
  
    h_motionblur = h_mb{i+1};
    
    %im_r_plain = deconvlucy(im_blurred,h_motionblur,num_it);
    im_edgetaper = edgetaper(im_blurred, h_gaussian);
    im_r_edgetaper = deconvlucy(im_edgetaper,h_motionblur,num_it);

    im_r_mat{i+1} = im_r_edgetaper;
    im_r_mat_cut{i+1} = im_r_edgetaper(N_px/2-25:N_px/2+25,N_px/2-50:N_px/2+50);
    
end

% % SNR and frequency response:
% snr_r = zeros(1,length(t_int));
% snr_blur = zeros(1,length(t_int));
% for i = 1:length(blur_len)
%     im_power = sum(double(im_r_mat_cut{1}(:).^2));
%     %SNR between original and recovered image:
%     im_diff_r = im_r_mat_cut{1}-im_r_mat_cut{i+1};
%     diff_r_power = sum(double(im_diff_r(:).^2));
%     snr_r(i) = im_power./diff_r_power;
%     %SNR between original and blurred image:
%     im_diff_blur = im_blurred_cut{1}-im_blurred_cut{i+1};
%     diff_blur_power = sum(double(im_diff_blur(:).^2));
%     snr_blur(i) = im_power./diff_blur_power;
% end
% u = 20;
% H_20 = 1./(pi*u*v_im).*sin(pi*u*v_im*t_int);
% H_20_norm = H_20./t_int;
% %plot SNR and frequency response together:
% clear title
% figure
% plot(t_int,10*log10(snr_blur),'s-')
% hold on
% [AX,H1,H2] = plotyy(t_int,10*log10(snr_r),t_int,H_20_norm);
% set(get(AX(1),'Ylabel'),'String','SNR (dB)') 
% set(get(AX(2),'Ylabel'),'String','Normalized |H( f_x = 20 )|','color','r') 
% set(AX(2),'YColor','r')
% set(H1,'Marker','o')
% set(H2,'Color','r')
% grid on
% legend('SNR blurred image','SNR recovered image','Frequency response')
% xlabel('Integration time [s]')
% plot([2.1 2.1],[10 40],'k--')
 
% plotting of many image segments:
clear title
clear titles
%index = [10 12 14 15 16 17 18 20]; %long int times
index = [1 2 4 6 8 10 12 14]; %short int times
%index = [6 12 17]; % t_int=[1 1.6 2.1], selction for report
t_int(index)
titles{1}='Original image';
plot_r{1} = im_r_mat_cut{1};
plot_blur{1} = im_blurred_cut{1};
plot_combo = cell(1,6);
titles_combo = cell(1,6);
%makin image stacks for plotting:
for i = 1:length(index)
    title = ['Exposure time = ' num2str(t_int(index(i))) ];
    titles{i+1} = title;
    plot_r{i+1} = im_r_mat_cut{index(i)+1};
    plot_blur{i+1} = im_blurred_cut{index(i)+1};

    plot_combo{3*i-2} = plot_blur{i+1}; %dummy image
    titles_combo{3*i-2} = ' ';
    plot_combo{3*i-1} =  plot_blur{i+1};
    titles_combo{3*i-1} =  ' ';

    plot_combo{3*i} = plot_r{i+1};
    titles_combo{3*i} =  ' ';
end
plot_im_stack(plot_blur,'q',titles)
plot_im_stack(plot_r,'q',titles)

%plot_im_stack(plot_combo,'q',titles_combo)

%% Testing for deviations in speed:
%sine test image
N_px = 256;
nr_periods = 20;
intensity = 0.6;
amplitude = 0.5*intensity;
angle = 10;
im_sine = make_sinus_image(N_px, nr_periods, intensity, amplitude,angle);

%blurred image
v_im = 0.024; %image velocity relative to image size!
t_int_test = 1.6;
blur_angle = 0;
blur_len = v_im*t_int_test;
%[im_blurred_sine h_mb] = motionblur_maker(im_sine, blur_len*N_px, blur_angle);
%Recovering image with varying estimated image speed:
%v_im_fake = [1 0.6 0.8 1.1 1.2]*v_im;
v_im_fake = [1 0.9 1.1]*v_im;
blur_len_fake = v_im_fake.*t_int_test;

%chirp image or sine images:
%chirp:
im_test = im_chirp;
N_px = number_of_pixels;
[im_blurred_mat_chirp h_mb] = motionblur_maker(im_test, blur_len*N_px, blur_angle);
im_blurred = im_blurred_mat_chirp{2};
im_r_fake = cell(1,length(blur_len_fake));
im_r_fake{1} = im_chirp;
for i = 1:length(blur_len_fake)
    h_motionblur = fspecial('motion', blur_len_fake(i)*N_px, blur_angle);
    im_r_fake{i+1} = motionblur_deconv(im_blurred, h_motionblur);
end
clear titles
clear title
%titles = {'-40%', '-20%', '+10%', '+20%'};
titles = {'Original image', 'Recovered image, correct speed' '-10% deviation in speed','+10% deviation in speed',};
plot_im_stack(im_r_fake,'l',titles)
figure
imshow(im_r_fake{2})
%title('correct image speed')
figure
imshow(im_r_fake{1})
%title('original image')

%% Testing with noise:
v_im = 0.024; %image velocity relative to image size!
blur_angle = 0;
blur_len = v_im*t_int;

%make test image without noise:
im_size = 256;
number_of_periods = 20;
t_int = 1.6;
SNR_factor = [50 100];
sine_dc = 0.6; % DC level of sine images per second
sine_angle = 10;
sine_amp = 0.05*sine_dc;
im_sine = make_sinus_image(im_size, number_of_periods, sine_dc, sine_amp,sine_angle);
%blur image:
[im_blurred h_mb] = motionblur_maker(im_sine, blur_len*im_size, blur_angle);
%add noise:
new_im_size = size(im_blurred{2},1);
noise_std = sine_dc./(SNR_factor*sqrt(t_int));
im_blurred_noisy1 = im_blurred{2}+(uint8(256*noise_std(1)*randn(new_im_size)));
im_blurred_noisy2 = im_blurred{2}+(uint8(256*noise_std(2)*randn(new_im_size)));
%recover:
im_rec_noisy1 = motionblur_deconv(im_blurred_noisy1,h_mb{2});
im_rec_noisy2 = motionblur_deconv(im_blurred_noisy2,h_mb{2});
im_rec = motionblur_deconv(im_blurred{2},h_mb{2});
%plot:
%im_plot = cell(1,5);
% titles = cell(1,5);
% titles = {'','','','','',};
% im_plot{1} = im_blurred{1};
% im_plot{2} = im_blurred{2};
% im_plot{3} = im_blurred_noisy;
% im_plot{4} = im_rec;
% im_plot{5} = im_rec_noisy;
% plot_im_stack(im_plot,'q',titles)

% cut out segments for plotting:
im_plot = cell(1,4);
im_plot{1} = im_blurred_noisy1;
im_plot{2} = im_rec_noisy1;
im_plot{3} = im_blurred_noisy2;
im_plot{4} = im_rec_noisy2;
N_px = new_im_size;
for i = 1:length(im_plot)
    im_plot_cut{i} = im_plot{i}(N_px/2-25:N_px/2+25,N_px/2-50:N_px/2+50);
end

titles = {'','','','',};
plot_im_stack(im_plot_cut,'q',titles)
