% draft for smart subplot-function
function plot_im_stack(im_cell, mode, title_cell)

 n_total = length(im_cell); %number 
% Quadratic constellation
if(mode == 'q')
    % Determining the numbers of figures and plots in each figure:
    number_of_figures = ceil(n_total/12);
    n = 12*ones(1,number_of_figures);
    n_last_figure = mod(n_total,12);
    n(number_of_figures) = n_last_figure;
    
    for i=1:number_of_figures
        % determining the number of rows to plot
        n = n(i);
        if(n < 4)
            rows(i) = 1;
        elseif(n >= 4 && n < 9)
            rows(i) = 2;
        elseif(n >= 9 && n <= 12)
            rows(i) = 3;
        end
    %number of columns:
    columns(i) = ceil(n/rows(i));
    end
    
elseif(mode == 'l')
    number_of_figures = ceil(n_total/4);
    n = 4*ones(1,number_of_figures);
    n(number_of_figures) = mod(n_total,12);
    rows = n;
    columns = ones(1,number_of_figures);
elseif(mode == 'w')
    number_of_figures = ceil(n_total/4);
    n = 4*ones(1,number_of_figures);
    n(number_of_figures) = mod(n_total,12);
    columns = n;
    rows = ones(1,number_of_figures);
else 
    disp('Invalid plot constellation')
end
    
    %making subplots:
    plot_count = 0;
    for k = 1:number_of_figures
        figure
        for j = 1:n(k)
           plot_count = plot_count+1;
           subplot(rows(k),columns(k),j) 
           imshow(im_cell{plot_count})
           if(nargin==3)
           title(title_cell{plot_count})
           end
        end
        %set(gcf, 'Position', get(0,'Screensize')); % Maximize figure. 
    end
end
